Index: typo3/sysext/cms/ext_tables.sql
===================================================================
--- typo3/sysext/cms/ext_tables.sql	(revision 2707)
+++ typo3/sysext/cms/ext_tables.sql	(working copy)
@@ -338,11 +338,6 @@
   titleText text NOT NULL,
   longdescURL text NOT NULL,
   header_layout varchar(30) DEFAULT '0' NOT NULL,
-  text_align varchar(6) DEFAULT '' NOT NULL,
-  text_face tinyint(3) unsigned DEFAULT '0' NOT NULL,
-  text_size tinyint(3) unsigned DEFAULT '0' NOT NULL,
-  text_color tinyint(3) unsigned DEFAULT '0' NOT NULL,
-  text_properties tinyint(3) unsigned DEFAULT '0' NOT NULL,
   menu_type varchar(30) DEFAULT '0' NOT NULL,
   list_type varchar(36) DEFAULT '0' NOT NULL,
   table_border tinyint(3) unsigned DEFAULT '0' NOT NULL,
Index: typo3/sysext/cms/tbl_tt_content.php
===================================================================
--- typo3/sysext/cms/tbl_tt_content.php	(revision 2707)
+++ typo3/sysext/cms/tbl_tt_content.php	(working copy)
@@ -304,92 +304,6 @@
 				'softref' => 'typolink_tag,images,email[subst],url'
 			)
 		),
-		'text_align' => Array (
-			'exclude' => 1,
-			'label' => 'LLL:EXT:cms/locallang_ttc.php:text_align',
-			'config' => Array (
-				'type' => 'select',
-				'items' => Array (
-					Array('', ''),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_align.I.1', 'center'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_align.I.2', 'right'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_align.I.3', 'left')
-				),
-				'default' => ''
-			)
-		),
-		'text_face' => Array (
-			'exclude' => 1,
-			'label' => 'LLL:EXT:cms/locallang_ttc.php:text_face',
-			'config' => Array (
-				'type' => 'select',
-				'items' => Array (
-					Array('LLL:EXT:lang/locallang_general.php:LGL.default_value', '0'),
-					Array('Times', '1'),
-					Array('Verdana', '2'),
-					Array('Arial', '3')
-				),
-				'default' => '0'
-			)
-		),
-		'text_size' => Array (
-			'exclude' => 1,
-			'label' => 'LLL:EXT:cms/locallang_ttc.php:text_size',
-			'config' => Array (
-				'type' => 'select',
-				'items' => Array (
-					Array('LLL:EXT:lang/locallang_general.php:LGL.default_value', '0'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.1', '1'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.2', '2'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.3', '3'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.4', '4'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.5', '5'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.6', '10'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_size.I.7', '11')
-				),
-				'default' => '0'
-			)
-		),
-		'text_color' => Array (
-			'exclude' => 1,
-			'label' => 'LLL:EXT:cms/locallang_ttc.php:text_color',
-			'config' => Array (
-				'type' => 'select',
-				'items' => Array (
-					Array('LLL:EXT:lang/locallang_general.php:LGL.default_value', '0'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.1', '1'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.2', '2'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.3', '200'),
-					Array('-----','--div--'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.5', '240'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.6', '241'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.7', '242'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.8', '243'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.9', '244'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.10', '245'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.11', '246'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.12', '247'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.13', '248'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.14', '249'),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_color.I.15', '250')
-				),
-				'default' => '0'
-			)
-		),
-		'text_properties' => Array (
-			'exclude' => 1,
-			'label' => 'LLL:EXT:cms/locallang_ttc.php:text_properties',
-			'config' => Array (
-				'type' => 'check',
-				'items' => Array (
-					Array('LLL:EXT:cms/locallang_ttc.php:text_properties.I.0', ''),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_properties.I.1', ''),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_properties.I.2', ''),
-					Array('LLL:EXT:cms/locallang_ttc.php:text_properties.I.3', '')
-				),
-				'cols' => 4
-			)
-		),
 		'image' => Array (
 #			'l10n_mode' => 'mergeIfNotBlank',
 			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.images',
@@ -968,8 +882,8 @@
 	'types' => Array (
 		'1' => 	Array('showitem' => 'CType'),
 		'header' => 	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, subheader;;8'),
-		'text' => 		Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, bodytext;;9;richtext:rte_transform[flag=rte_enabled|mode=ts_css];3-3-3, rte_enabled, text_properties'),
-		'textpic' => 	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, bodytext;;9;richtext:rte_transform[flag=rte_enabled|mode=ts_css];3-3-3, rte_enabled, text_properties, --div--, image;;;;4-4-4, imageorient;;2, imagewidth;;13,
+		'text' =>	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, bodytext;;;richtext:rte_transform[flag=rte_enabled|mode=ts_css];3-3-3, rte_enabled'),
+		'textpic' =>	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, bodytext;;;richtext:rte_transform[flag=rte_enabled|mode=ts_css];3-3-3, rte_enabled, --div--, image;;;;4-4-4, imageorient;;2, imagewidth;;13,
 			--palette--;LLL:EXT:cms/locallang_ttc.php:ALT.imgLinks;7,
 			--palette--;LLL:EXT:cms/locallang_ttc.php:ALT.imgOptions;11,
 			imagecaption;;5,
@@ -980,8 +894,8 @@
 			--palette--;LLL:EXT:cms/locallang_ttc.php:ALT.imgOptions;11,
 			 imagecaption;;5,
 			 altText;;;;1-1-1,titleText,longdescURL'),
-		'bullets' => 	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, layout;;;;3-3-3, bodytext;;9;nowrap, text_properties'),
-		'table' => 		Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, layout;;10;button;3-3-3, cols, bodytext;;9;nowrap:wizards[table], text_properties'),
+		'bullets' =>	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, layout;;;;3-3-3, bodytext;;;nowrap'),
+		'table' =>		Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, layout;;10;button;3-3-3, cols, bodytext;;;nowrap:wizards[table]'),
 		'splash' => 	Array('showitem' => 'CType;;4;button;1-1-1, header;LLL:EXT:lang/locallang_general.php:LGL.name;;;2-2-2, splash_layout, bodytext;;;;3-3-3, image;;6'),
 		'uploads' => 	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, media;;;;5-5-5,
 			select_key;LLL:EXT:cms/locallang_ttc.php:select_key.ALT.uploads,
@@ -1000,8 +914,7 @@
 		'login' => 		Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2,
 			pages;LLL:EXT:cms/locallang_ttc.php:pages.ALT.login;;;5-5-5'),
 		'shortcut' => 	Array('showitem' => 'CType;;4;button;1-1-1, header;LLL:EXT:lang/locallang_general.php:LGL.name;;;2-2-2, records;;;;5-5-5, layout'),
-		'list' => 		Array(
-							'showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, --div--, list_type;;;;5-5-5, layout, select_key, pages;;12',
+		'list' =>	Array('showitem' => 'CType;;4;button;1-1-1, header;;3;;2-2-2, --div--, list_type;;;;5-5-5, layout, select_key, pages;;12',
 							'subtype_value_field' => 'list_type',
 							'subtypes_excludelist' => Array(
 								'' => 'layout,select_key,pages',	// When no plugin is selected.
@@ -1034,7 +947,6 @@
 		'6' => Array('showitem' => 'imagewidth,image_link'),
 		'7' => Array('showitem' => 'image_link, image_zoom'),
 		'8' => Array('showitem' => 'layout'),
-		'9' => Array('showitem' => 'text_align,text_face,text_size,text_color'),
 		'10' => Array('showitem' => 'table_bgColor, table_border, table_cellspacing, table_cellpadding'),
 		'11' => Array('showitem' => 'image_compression, image_effects, image_frames'),
 		'12' => Array('showitem' => 'recursive'),
Index: typo3/sysext/cms/layout/class.tx_cms_layout.php
===================================================================
--- typo3/sysext/cms/layout/class.tx_cms_layout.php	(revision 2707)
+++ typo3/sysext/cms/layout/class.tx_cms_layout.php	(working copy)
@@ -1692,7 +1692,6 @@
 			case 'image':
 				if ($row['CType']=='text' || $row['CType']=='textpic')	{
 					if ($row['bodytext'])	{
-						$this->getProcessedValue('tt_content','text_align,text_face,text_size,text_color,text_properties',$row,$infoArr);
 						$out.= $this->infoGif($infoArr).
 								$this->linkEditContent($this->renderText($row['bodytext']),$row).'<br />';
 					}
@@ -1715,14 +1714,14 @@
 			break;
 			case 'bullets':
 				if ($row['bodytext'])	{
-					$this->getProcessedValue('tt_content','layout,text_align,text_face,text_size,text_color,text_properties',$row,$infoArr);
+					$this->getProcessedValue('tt_content','layout',$row,$infoArr);
 					$out.=	$this->infoGif($infoArr).
 							$this->linkEditContent($this->renderText($row['bodytext']),$row).'<br />';
 				}
 			break;
 			case 'table':
 				if ($row['bodytext'])	{
-					$this->getProcessedValue('tt_content','table_bgColor,table_border,table_cellspacing,cols,layout,text_align,text_face,text_size,text_color,text_properties',$row,$infoArr);
+					$this->getProcessedValue('tt_content','table_bgColor,table_border,table_cellspacing,cols,layout',$row,$infoArr);
 					$out.=	$this->infoGif($infoArr).
 							$this->linkEditContent($this->renderText($row['bodytext']),$row).'<br />';
 				}